if not MusicSync
	rawset(_G,"MusicSync", {})
end

MusicSync.switchobjects = {}
MusicSync.prevtime = 0
MusicSync.switchcd = 0

//Global music sync
addHook("PreThinkFrame", do
	if not (mapheaderinfo[gamemap].rhythmmap) then return end
	MusicSync.level = (1000*leveltime/35) --tics to milliseconds
	
	//Variables from map header
	MusicSync.switchstart = tonumber(mapheaderinfo[gamemap].millisecondstart)
	MusicSync.switchtime = tonumber(mapheaderinfo[gamemap].millisecondswitch)
	
	local m = MusicSync
	local timer = (m.level-m.switchstart)%m.switchtime
	local leeway = abs(m.prevtime-timer)
	MusicSync.switch = false
	if MusicSync.switchcd then MusicSync.switchcd = max($-1,0) end
	
	if leveltime == 2
		S_FadeMusic(100, m.switchtime/2)
	end
	
	if max(timer-leeway,0) == 0 --"MusicSync.switch" is true on beat (single)
	and m.level >= m.switchstart
	and not MusicSync.switchcd
		MusicSync.switch = true
		MusicSync.switchcd = max((35*m.switchstart/1000)/5,0)
	end
	MusicSync.prevtime = timer
	
	if gamestate != GS_LEVEL
	and MusicSync.switchobjects
	and #MusicSync.switchobjects
		MusicSync.switchobjects = {}
	end
end)

//Local music sync
addHook("PlayerThink", function(p)
	if not (mapheaderinfo[gamemap].rhythmmap) then return end
	
	if not MusicSync then return end
	if p != consoleplayer then return end
	if not S_MusicPlaying(consoleplayer) then return end --music even enabled? whats the point to catching up if you cant hear
	if S_MusicName(p) != mapheaderinfo[gamemap].musname then return end
	
	local millitics = MusicSync.level
	local millimusic = S_GetMusicPosition()
	local musiclength = S_GetMusicLength()
	local musicloop = S_GetMusicLoopPoint(consoleplayer)
	
	local setmusictics = millitics
	if millitics >= musicloop --Looping (kinda buggy but works good enough)
		setmusictics = musicloop+((millitics-musicloop)%(musiclength-musicloop))
	end
	if abs(setmusictics-millimusic) >= 100 --Catch up to current time
		S_SetMusicPosition(setmusictics+20)
	end
end)

addHook("NetVars", function(net)
	MusicSync = net(MusicSync)
end)
//Debug hud
/*hud.add(function(v,p,c)
	local millitics = MusicSync.level
	local millimusic = S_GetMusicPosition()
	local musiclength = S_GetMusicLength()
	
	v.drawString(16,100,"millitics: "..millitics, V_SNAPTOLEFT,"thin")
	v.drawString(16,112,"millimusic: "..millimusic, V_SNAPTOLEFT,"thin")
	v.drawString(16,124,"desync: "..millitics-millimusic, V_SNAPTOLEFT,"thin")
	v.drawString(16,136,"musiclength: "..musiclength, V_SNAPTOLEFT,"thin")
end,"game")*/